// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: stabilisense.proto

package stabilisense_proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ReliabilityServiceClient is the client API for ReliabilityService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ReliabilityServiceClient interface {
	GetLastKeys(ctx context.Context, in *GetLastKeysRequest, opts ...grpc.CallOption) (*GetLastKeysResponse, error)
	SendReliabilityRecords(ctx context.Context, in *SendReliabilityRecordsRequest, opts ...grpc.CallOption) (*KeyResponse, error)
	SendReliabilityStabilityMetrics(ctx context.Context, in *SendReliabilityStabilityMetricsRequest, opts ...grpc.CallOption) (*TimeGeneratedResponse, error)
}

type reliabilityServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewReliabilityServiceClient(cc grpc.ClientConnInterface) ReliabilityServiceClient {
	return &reliabilityServiceClient{cc}
}

func (c *reliabilityServiceClient) GetLastKeys(ctx context.Context, in *GetLastKeysRequest, opts ...grpc.CallOption) (*GetLastKeysResponse, error) {
	out := new(GetLastKeysResponse)
	err := c.cc.Invoke(ctx, "/stabilisense.ReliabilityService/GetLastKeys", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *reliabilityServiceClient) SendReliabilityRecords(ctx context.Context, in *SendReliabilityRecordsRequest, opts ...grpc.CallOption) (*KeyResponse, error) {
	out := new(KeyResponse)
	err := c.cc.Invoke(ctx, "/stabilisense.ReliabilityService/SendReliabilityRecords", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *reliabilityServiceClient) SendReliabilityStabilityMetrics(ctx context.Context, in *SendReliabilityStabilityMetricsRequest, opts ...grpc.CallOption) (*TimeGeneratedResponse, error) {
	out := new(TimeGeneratedResponse)
	err := c.cc.Invoke(ctx, "/stabilisense.ReliabilityService/SendReliabilityStabilityMetrics", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ReliabilityServiceServer is the server API for ReliabilityService service.
// All implementations must embed UnimplementedReliabilityServiceServer
// for forward compatibility
type ReliabilityServiceServer interface {
	GetLastKeys(context.Context, *GetLastKeysRequest) (*GetLastKeysResponse, error)
	SendReliabilityRecords(context.Context, *SendReliabilityRecordsRequest) (*KeyResponse, error)
	SendReliabilityStabilityMetrics(context.Context, *SendReliabilityStabilityMetricsRequest) (*TimeGeneratedResponse, error)
	mustEmbedUnimplementedReliabilityServiceServer()
}

// UnimplementedReliabilityServiceServer must be embedded to have forward compatible implementations.
type UnimplementedReliabilityServiceServer struct {
}

func (UnimplementedReliabilityServiceServer) GetLastKeys(context.Context, *GetLastKeysRequest) (*GetLastKeysResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetLastKeys not implemented")
}
func (UnimplementedReliabilityServiceServer) SendReliabilityRecords(context.Context, *SendReliabilityRecordsRequest) (*KeyResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendReliabilityRecords not implemented")
}
func (UnimplementedReliabilityServiceServer) SendReliabilityStabilityMetrics(context.Context, *SendReliabilityStabilityMetricsRequest) (*TimeGeneratedResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendReliabilityStabilityMetrics not implemented")
}
func (UnimplementedReliabilityServiceServer) mustEmbedUnimplementedReliabilityServiceServer() {}

// UnsafeReliabilityServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ReliabilityServiceServer will
// result in compilation errors.
type UnsafeReliabilityServiceServer interface {
	mustEmbedUnimplementedReliabilityServiceServer()
}

func RegisterReliabilityServiceServer(s grpc.ServiceRegistrar, srv ReliabilityServiceServer) {
	s.RegisterService(&ReliabilityService_ServiceDesc, srv)
}

func _ReliabilityService_GetLastKeys_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetLastKeysRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReliabilityServiceServer).GetLastKeys(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/stabilisense.ReliabilityService/GetLastKeys",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReliabilityServiceServer).GetLastKeys(ctx, req.(*GetLastKeysRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReliabilityService_SendReliabilityRecords_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendReliabilityRecordsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReliabilityServiceServer).SendReliabilityRecords(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/stabilisense.ReliabilityService/SendReliabilityRecords",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReliabilityServiceServer).SendReliabilityRecords(ctx, req.(*SendReliabilityRecordsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReliabilityService_SendReliabilityStabilityMetrics_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SendReliabilityStabilityMetricsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReliabilityServiceServer).SendReliabilityStabilityMetrics(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/stabilisense.ReliabilityService/SendReliabilityStabilityMetrics",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReliabilityServiceServer).SendReliabilityStabilityMetrics(ctx, req.(*SendReliabilityStabilityMetricsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ReliabilityService_ServiceDesc is the grpc.ServiceDesc for ReliabilityService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ReliabilityService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "stabilisense.ReliabilityService",
	HandlerType: (*ReliabilityServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetLastKeys",
			Handler:    _ReliabilityService_GetLastKeys_Handler,
		},
		{
			MethodName: "SendReliabilityRecords",
			Handler:    _ReliabilityService_SendReliabilityRecords_Handler,
		},
		{
			MethodName: "SendReliabilityStabilityMetrics",
			Handler:    _ReliabilityService_SendReliabilityStabilityMetrics_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "stabilisense.proto",
}
